﻿using Kivii.Linq;
using Kivii.Samples.Entities;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Samples.Transforms
{
    #region CRUDQ
    //[RequiresAnyRole(SystemRoles.Everyone)]
    public class SampleQuery : RestfulQuery<Sample>
    {
        public List<Guid> BizKvids { get; set; }
        public override bool OnPreRestfulQuery(IRequest req, IResponse res, IDbConnection dbConnection, IRestfulQueryResponse<Sample> rtns, ref Expression<Func<Sample, bool>> where)
        {
            if (!BizKvids.IsNullOrEmpty()) where = o => Sql.In(o.BizKvid, BizKvids);
            return base.OnPreRestfulQuery(req, res, dbConnection, rtns, ref where);
        }
    }
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class SampleCreate : RestfulCreate<Sample>
    {
    }
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class SampleUpdate : RestfulUpdate<Sample>
    {
    }
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class SampleRead : RestfulRead<Sample>
    {
    }

    [RequiresAnyRole(SystemRoles.Everyone)]
    public class SampleDelete : RestfulDelete<Sample>
    {
    }

    //public class SampleAssigningResponse : RestfulUpdateResponse<Sample>
    //{

    //}
    //[RequiresAnyRole(SystemRoles.Everyone)]
    //public class SampleAssigning : RestfulExecution<Sample>
    //{
    //    //public List<Guid> SampleKvids { get; set; }
    //    public List<Sample> Samples { get; set; }
    //    public StatusType StatusType { get; set; }
    //    public override object OnExecution(IRequest req, IResponse res)
    //    {
    //        Samples.ThrowIfNullOrEmpty("请传入要流转的样品信息!");
    //        var conn = KiviiContext.GetOpenedDbConnection<Sample>();
    //        var samples = conn.SelectByIds<Sample>(Samples.ConvertAll(p => p.Kvid));
    //        samples.ThrowIfNullOrEmpty("未找到要流转的样品信息!");
    //        var title = string.Empty;
    //        var type = StatusType.ToString();
    //        var from = string.Empty;
    //        var to = string.Empty;
    //        var operatorName = string.Empty;
    //        switch (StatusType)
    //        {
    //            case StatusType.Created:
    //                title = "样品创建";
    //                //type = "创建";
    //                from = "委托受理";
    //                to = "样品受理交接";
    //                operatorName = "业务发展科";
    //                break;
    //            case StatusType.CommissionAssign:
    //                title = "受理交接";
    //                //type = "交接";
    //                from = "样品受理交接";
    //                to = "实验室领取交接";
    //                operatorName = "业务发展科";
    //                break;
    //            case StatusType.TaskAssign:
    //                title = "领取交接";
    //                //type = "交接";
    //                from = "实验室领取交接";
    //                to = "任务分派";
    //                operatorName = "开样组";
    //                break;
    //            default:
    //                break;
    //        }
    //        var preUpdateSamples = new List<Sample>();
    //        foreach (var item in samples)
    //        {
    //            var sample = Samples.FirstOrDefault(o => o.Kvid == item.Kvid);
    //            if (sample != null) item.AssignTime = sample.AssignTime;

    //            if (StatusType == StatusType.CommissionAssign)
    //            {
    //                if (item.Status == (int)StatusType.Created) preUpdateSamples.Add(item);
    //            }
    //            else if (StatusType == StatusType.TaskAssign)
    //            {
    //                if (item.Status == (int)StatusType.CommissionAssign) preUpdateSamples.Add(item);
    //            }
    //            else
    //            {
    //                preUpdateSamples.Add(item);
    //            }
    //        }
    //        var rtns = new SampleAssigningResponse();
    //        rtns.Results = new List<Sample>();
    //        var trans = conn.OpenTransaction();
    //        try
    //        {
    //            var updateLamda = conn.From<Sample>();
    //            updateLamda = updateLamda.Update(o => o.Status);
    //            updateLamda = updateLamda.Where(o => Sql.In(o.Kvid, preUpdateSamples.ConvertAll(p => p.Kvid)));
    //            conn.UpdateOnly(new Sample { Status = (int)StatusType }, updateLamda);
    //            preUpdateSamples.ForEach(o => o.Status = (int)StatusType);
    //            rtns.Results.AddRange(preUpdateSamples);
    //            foreach (var item in preUpdateSamples)
    //            {
    //                var assign = new Route();
    //                assign.SampleKvid = item.Kvid;
    //                assign.SampleName = item.Name;
    //                assign.BizId = item.BizId;
    //                assign.BizKvid = item.BizKvid;
    //                assign.BizType = item.BizType;
    //                assign.Title = title;
    //                assign.Type = type;
    //                //assign.From = from;
    //                //assign.To = to;
    //                //assign.PlanStartTime = DateTime.Now.AddHours(3);
    //                assign.OperateTime = item.AssignTime != null ? item.AssignTime.Value : DateTime.Now;
    //                assign.OperatorName = operatorName;
    //                conn.Insert(assign);
    //            }
    //            trans.Commit();

    //        }
    //        catch (Exception ex)
    //        {
    //            trans.Rollback();
    //            throw ex;
    //        }
    //        return rtns;
    //    }
    //}
    #endregion

    [RequiresAnyRole(SystemRoles.Everyone)]
    [Api(Description ="生成样品")]
    public class SampleAccept : RestfulExecution<Sample>
    {
        public Sample Item { get; set; }//要创建的样品信息

        public Location Location { get; set; }//地点位置信息,只需要InternalCode

        public Route Route { get; set; }//自定义路由信息,可不填写

        public override object OnExecution(IRequest req, IResponse res)
        {
            (Item == null).ThrowIfTrue("缺少要创建的样品实例!");
            (Item.Name.IsNullOrEmpty()).ThrowIfTrue("缺少样品名称信息!");
            (Location == null).ThrowIfTrue("缺少目的地点配置信息!");
            (Location.InternalCode.IsNullOrEmpty()).ThrowIfTrue("缺少目的地点配置InternalCode信息");
            var conn = KiviiContext.GetOpenedDbConnection<Location>();
            var local= conn.Single<Location>(o => o.InternalCode == Location.InternalCode);
            (local == null).ThrowIfTrue($"未找到{Location.InternalCode}目的地点配置信息!");

            var rtns = new RestfulCreateResponse<Sample>();
            rtns.Results = new List<Sample>();

            var accept = Item.Accept(local, Route);
            rtns.Results.Add(accept);
            return rtns;
        }
    }

    [RequiresAnyRole(SystemRoles.Everyone)]
    [Api(Description = "样品拆分")]
    public class SampleSplit:RestfulExecution<Sample>
    {
        public Guid Kvid { get; set; }//要拆分的样品Kvid

        public List<Sample> Samples { get; set; }//拆分出的子样品信息

        public Location Location { get; set; }//地点位置信息,只需要InternalCode

        public override object OnExecution(IRequest req, IResponse res)
        {
            (Kvid == Guid.Empty).ThrowIfTrue("缺少要拆分的样品Kvid");
            Samples.ThrowIfNullOrEmpty("缺少拆分的样品信息");
            (Location == null).ThrowIfTrue("缺少目的地点配置信息!");
            (Location.InternalCode.IsNullOrEmpty()).ThrowIfTrue("缺少目的地点配置InternalCode信息");

            var conn = KiviiContext.GetOpenedDbConnection<Location>();
            var local = conn.Single<Location>(o => o.InternalCode == Location.InternalCode);
            (local == null).ThrowIfTrue($"未找到{Location.InternalCode}目的地点配置信息!");

            var sample = new Sample();
            sample.Kvid = Kvid;

            var splited = sample.Split(Samples, local);
            var rtns = new RestfulCreateResponse<Sample>();
            rtns.Results = new List<Sample>();
            rtns.Results.AddRange(splited);

            return rtns;
        }
    }

    //[RequiresAnyRole(SystemRoles.Everyone)]
    [Api(Description = "样品流转")]
    public class SampleAssign : RestfulExecution<Sample>
    {
        public Guid Kvid { get; set; }//要流转样品信息
        public List<Guid> Kvids { get; set; }//要流转样品信息

        public Location Location { get; set; }//地点位置信息,只需要InternalCode

        public Route Route { get; set; }//自定义路由信息,可不填写

        public override object OnExecution(IRequest req, IResponse res)
        {
            (Kvid == Guid.Empty && Kvids.IsNullOrEmpty()).ThrowIfTrue("缺少要流转的样品信息!");
            Location.ThrowIfNull("缺少目的地点信息!");
            (Location.InternalCode.IsNullOrEmpty()).ThrowIfTrue("缺少目的地点配置InternalCode信息");

            var conn = KiviiContext.GetOpenedDbConnection<Location>();
            var local = conn.Single<Location>(o => o.InternalCode == Location.InternalCode);
            (local == null).ThrowIfTrue($"未找到{Location.InternalCode}目的地点配置信息!");

            if (Kvids.IsNullOrEmpty()) Kvids = new List<Guid>();
            if (Kvid != Guid.Empty) Kvids.Add(Kvid);

            var rtns = new RestfulUpdateResponse<Sample>();
            rtns.Results = new List<Sample>();

            foreach (var kvid in Kvids)
            {
                var sample = new Sample();
                sample.Kvid = kvid;

                var assign = sample.Assign(local, Route);
                rtns.Results.Add(assign);
            }
            return rtns;
        }
    }

    //[RequiresAnyRole(SystemRoles.Everyone)]
    [Api(Description = "所在地样品")]
    public class SampleLocationEx : RestfulExecution<Sample>
    {
        #region QueryArgs
        public virtual int? Skip { get; set; }

        public virtual int? Take { get; set; }

        public virtual string OrderBy { get; set; }

        public string OrderByDesc { get; set; }

        public virtual string Include { get; set; }

        public virtual string Fields { get; set; }

        public string QueryKeys { get; set; }

        public string QueryValues { get; set; }

        #endregion
        public Guid LocationKvid { get; set; }
        public string LocationInternalCode { get; set; }

        public override object OnExecution(IRequest req, IResponse res)
        {
            (LocationKvid == Guid.Empty && LocationInternalCode.IsNullOrEmpty()).ThrowIfTrue("请传入要查询的地点信息!");
            var conn = KiviiContext.GetOpenedDbConnection<Location>();
            Location location = null;
            if (LocationKvid != Guid.Empty) location = conn.SingleById<Location>(LocationKvid);
            if (location == null)
            {
                if (!LocationInternalCode.IsNullOrEmpty()) location = conn.Single<Location>(o => o.InternalCode == LocationInternalCode);
                location.ThrowIfNull("未找到指定的地点信息!");
            }
            var queryRoutes = conn.From<Route>();
            queryRoutes.Where(o => o.CurrentLocationKvid == location.Kvid && o.NextLocationKvid == Guid.Empty);
            queryRoutes.Select(o => o.SampleKvid);

            var dynamicParams = Request.GetRequestParams();
            var autoQuery = Request.TryResolve<IAutoQueryDb>();
            autoQuery.IncludeTotal = true;
            var request = new RestfulQuery<Sample>();
            request = request.PopulateWith(this);
            var sqlExpress = autoQuery.CreateQuery(Request, conn, request, dynamicParams);
            sqlExpress.Where(o => Sql.In(o.Kvid, queryRoutes));
            var rtns = autoQuery.Execute(Request, conn, request, sqlExpress);

            //var samples = conn.Select<Sample>(o => Sql.In(o.Kvid, queryRoutes));
            //var rtns = new RestfulQueryResponse<Sample>();
            //rtns.Results = new List<Sample>();
            //rtns.Results.AddRange(samples);
            //rtns.Total = rtns.Results.Count;
            return rtns;
        }
    }
}
